package com.ejie.ab79.service;
import com.ejie.ab79.dao.ActuacionesJsonDao;
import com.ejie.x38.dto.JerarquiaDto;
import com.ejie.x38.dto.TableRequestDto;
import com.ejie.x38.dto.TableResponseDto;
import com.ejie.x38.dto.TableRowDto;
import java.util.List;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import com.ejie.ab79.model.ActuacionesJson;

/**
 * ActuacionesJsonServiceImpl  
 *  
 */

@Service(value = "actuacionesJsonService")
public class ActuacionesJsonServiceImpl implements ActuacionesJsonService {

	@Autowired
	private ActuacionesJsonDao actuacionesJsonDao;

	/**
	 * Inserts a single row in the ActuacionesJson table.
	 *
	 * @param actuacionesJson ActuacionesJson
	 * @return ActuacionesJson
	 */
	@Transactional(rollbackFor = Throwable.class)
	public ActuacionesJson add(ActuacionesJson actuacionesJson) {
		return this.actuacionesJsonDao.add(actuacionesJson);
	}

	/**
	 * Updates a single row in the ActuacionesJson table.
	 *
	 * @param actuacionesJson ActuacionesJson
	 * @return ActuacionesJson
	 */
	@Transactional(rollbackFor = Throwable.class)
	public ActuacionesJson update(ActuacionesJson actuacionesJson) {
		return this.actuacionesJsonDao.update(actuacionesJson);
	 }

	/**
	 * Finds a single row in the ActuacionesJson table.
	 *
	 * @param actuacionesJson ActuacionesJson
	 * @return ActuacionesJson
	 */
	public ActuacionesJson find(ActuacionesJson actuacionesJson) {
		return (ActuacionesJson) this.actuacionesJsonDao.find(actuacionesJson);
	}
	
	/**
	 * Deletes a single row in the ActuacionesJson table.
	 *
	 * @param actuacionesJson ActuacionesJson
	 */
	@Transactional(rollbackFor = Throwable.class)
	public void remove(ActuacionesJson actuacionesJson) {
		this.actuacionesJsonDao.remove(actuacionesJson);
	}

	/**
	 * Finds a list of rows in the ActuacionesJson table.
	 *
	 * @param actuacionesJson ActuacionesJson
	 * @param tableRequestDto TableRequestDto
	 * @return List<ActuacionesJson>
	 */
	public List<ActuacionesJson> findAll(ActuacionesJson actuacionesJson, TableRequestDto tableRequestDto){
		return (List<ActuacionesJson>) this.actuacionesJsonDao.findAll(actuacionesJson, tableRequestDto);
	}
    
	/**
	 * Finds rows in the ActuacionesJson table using like.
	 *
	 * @param actuacionesJson ActuacionesJson
	 * @param tableRequestDto TableRequestDto
     * @param startsWith Boolean	 
	 * @return List<ActuacionesJson>
	 */
	public List<ActuacionesJson> findAllLike(ActuacionesJson actuacionesJson, TableRequestDto tableRequestDto, Boolean startsWith){
		return (List<ActuacionesJson>) this.actuacionesJsonDao.findAllLike(actuacionesJson, tableRequestDto, startsWith);
	}

	/*
	 * OPERACIONES RUP_TABLE
	 */
	 
	/**
	 * Removes rows from the ActuacionesJson table.
	 *
	 * @param filterActuacionesJson ActuacionesJson
	 * @param tableRequestDto TableRequestDto
	 * @param startsWith Boolean
	 */	
	public void removeMultiple(ActuacionesJson filterActuacionesJson, TableRequestDto tableRequestDto,  Boolean startsWith){
		this.actuacionesJsonDao.removeMultiple(filterActuacionesJson, tableRequestDto, startsWith);
	}
        
	/**
	 * Filter method in the ActuacionesJson table.
	 *
	 * @param filterActuacionesJson ActuacionesJson
	 * @param tableRequestDto TableRequestDto
	 * @param startsWith Boolean
	 * @return TableResponseDto<ActuacionesJson>
	 */	
	public TableResponseDto< ActuacionesJson> filter(ActuacionesJson filterActuacionesJson, TableRequestDto tableRequestDto,  Boolean startsWith){
		List<ActuacionesJson> listaActuacionesJson =  this.actuacionesJsonDao.findAllLike(filterActuacionesJson, tableRequestDto, false);
		Long recordNum =  this.actuacionesJsonDao.findAllLikeCount(filterActuacionesJson != null ? filterActuacionesJson: new ActuacionesJson (),false);
		
		TableResponseDto<ActuacionesJson> usuarioDto = new TableResponseDto<ActuacionesJson>(tableRequestDto, recordNum, listaActuacionesJson);
		
		if (tableRequestDto.getMultiselection().getSelectedIds()!=null){
			List< TableRowDto< ActuacionesJson>> reorderSelection = this.actuacionesJsonDao.reorderSelection(filterActuacionesJson, tableRequestDto, startsWith);
			usuarioDto.setReorderedSelection(reorderSelection);
			usuarioDto.addAdditionalParam("reorderedSelection", reorderSelection);
			usuarioDto.addAdditionalParam("selectedAll", tableRequestDto.getMultiselection().getSelectedAll());
		}
		if (tableRequestDto.getSeeker().getSelectedIds()!=null){
			tableRequestDto.setMultiselection(tableRequestDto.getSeeker());
			List< TableRowDto< ActuacionesJson>> reorderSeeker = this.actuacionesJsonDao.reorderSelection(filterActuacionesJson, tableRequestDto, startsWith);
			usuarioDto.setReorderedSeeker(reorderSeeker);
			usuarioDto.addAdditionalParam("reorderedSeeker", reorderSeeker);
		}
		return usuarioDto;   
	}
    /**
	 * Searches rows in the ActuacionesJson table.
	 *
	 * @param filterActuacionesJson ActuacionesJson
	 * @param searchActuacionesJson ActuacionesJson
	 * @param tableRequestDto TableRequestDto
	 * @param startsWith Boolean
	 * @return List<TableRowDto<ActuacionesJson>>
	 */	
    public List< TableRowDto< ActuacionesJson>> search(ActuacionesJson filterActuacionesJson, ActuacionesJson searchActuacionesJson, TableRequestDto tableRequestDto, Boolean startsWith){
		return this.actuacionesJsonDao.search(filterActuacionesJson, searchActuacionesJson, tableRequestDto, startsWith);
	}
    
    /**
	 * Reorder the selection made in ActuacionesJson table.
	 *
	 * @param filterActuacionesJson ActuacionesJson
	 * @param tableRequestDto TableRequestDto
	 * @param startsWith Boolean
	 * @return Object
	 */	
    public Object reorderSelection(ActuacionesJson filterActuacionesJson, TableRequestDto tableRequestDto, Boolean startsWith){
		return this.actuacionesJsonDao.reorderSelection(filterActuacionesJson, tableRequestDto, startsWith);
	}
    
    /*
	 * OPERACIONES RUP_TABLE JERARQUIA
	 */
	 
	/**
	 * Finder method in the hierarchical the ActuacionesJson table.
	 *
	 * @param filterActuacionesJson ActuacionesJson
	 * @param tableRequestDto TableRequestDto
	 * @param startsWith Boolean
	 * @return TableResponseDto<JerarquiaDto<ActuacionesJson>>
	 */	
	public TableResponseDto<JerarquiaDto<ActuacionesJson>> jerarquia(ActuacionesJson filterActuacionesJson, TableRequestDto tableRequestDto, Boolean startsWith){
		List<JerarquiaDto<ActuacionesJson>> listaActuacionesJson =  this.actuacionesJsonDao.findAllLikeJerarquia(filterActuacionesJson, tableRequestDto);
		Long recordNum = this.actuacionesJsonDao.findAllLikeCountJerarquia(filterActuacionesJson, tableRequestDto);
		return new TableResponseDto<JerarquiaDto<ActuacionesJson>>(tableRequestDto, recordNum, listaActuacionesJson);
	}
	
	/**
	 * Finder method for siblings rows in the hierarchical the ActuacionesJson table.
	 *
	 * @param filterActuacionesJson ActuacionesJson
	 * @param tableRequestDto TableRequestDto
	 * @return TableResponseDto<JerarquiaDto<ActuacionesJson>>
	 */	
	public TableResponseDto<JerarquiaDto<ActuacionesJson>> jerarquiaChildren(ActuacionesJson filterActuacionesJson, TableRequestDto tableRequestDto){
		TableResponseDto<JerarquiaDto<ActuacionesJson>> tableResponseDto = new TableResponseDto<JerarquiaDto<ActuacionesJson>>();
		tableResponseDto.addAdditionalParam(TableResponseDto.CHILDREN, this.actuacionesJsonDao.findAllChild(filterActuacionesJson, tableRequestDto));
		return tableResponseDto;
	}
	
	/**
    * Exporta Datos al clipBoard
    *
    */
    public List<ActuacionesJson> getMultiple(ActuacionesJson filterActuacionesJson, TableRequestDto tableRequestDto,  Boolean startsWith){
		return this.actuacionesJsonDao.getMultiple(filterActuacionesJson, tableRequestDto, startsWith);
	}
      
	
	
}

